{% extends "base.html" %}

{% load staticfiles %}

{% block title %}Edit Risk Type{% endblock %}

{% block content %}

    <div id="risk_types_edit">

        <div class="box">
            <form v-on:submit.prevent="saveUpdatedRiskType()">
                <div class="box-header with-border bg-green-gradient">
                    <h3 class="box-title text-bold">Edit Risk Type</h3>
                </div>
                <div class="box-body">

                    <div>
                        <input class="col-sm-4 margin-bottom margin-r-5" style="height: 33px" type="text" v-model="typeName"
                               placeholder="Risk Type Name" v-model="type_name" id="risk_type">
                        <span id="risk_type_error" class="text-bold text-red" hidden></span>
                        <button type="button" class="btn btn-danger text-bold"
                                v-on:click.prevent="addNewRiskTypeField()">
                            <i class="fa fa-file"></i>&nbsp;Add Risk Type Field
                        </button>
                    </div>

                    <table class="table table-bordered">
                        <thead class="bg-gray-light">
                            <tr>
                                <th style="width: 10px">#</th>
                                <th>Field Name</th>
                                <th>Field Type</th>
                                <th style="width: 90px">Buttons</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr v-for="(riskTypeField, index) in riskTypeFields">
                                <td>${index + 1}</td>
                                <td>${riskTypeField.field_name}</td>
                                <td>
                                    <template v-if="riskTypeField.field_type != 'Enum'">
                                        ${riskTypeField.field_type}
                                    </template>
                                    <template v-else>
                                        ${riskTypeField.field_type}(
                                        <template v-for="(enumValue, index) in riskTypeField.enum_values">
                                            <span v-if="index == riskTypeField.enum_values.length - 1">
                                                 ${enumValue.value}
                                            </span>
                                            <span v-else>
                                                 ${enumValue.value},&nbsp;
                                            </span>
                                        </template>
                                        )
                                    </template>

                                </td>
                                <td>
                                    <button class="btn btn-primary btn-sm"
                                            v-on:click.prevent="editRiskTypeField(index)">
                                        <i class="fa fa-edit"></i>
                                    </button>
                                    <button class="btn btn-danger btn-sm"
                                            v-on:click.prevent="deleteRiskTypeField(index)">
                                        <i class="fa fa-trash-o fa-lg"></i>
                                    </button>
                                </td>
                            </tr>
                        </tbody>
                    </table>

                </div>

                <div class="box-footer">
                    <button type="submit" class="btn btn-primary pull-right text-bold" id="save_risk_type">
                        <i class="fa fa-save"></i>&nbsp;Save Updated Risk Type
                    </button>
                </div>
            </form>
        </div>

        <div class="modal fade" id="addRiskTypeFieldModal" tabindex="-1" role="dialog" aria-hidden="true">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header bg-light-blue-gradient">
                        <span class="modal-title text-bold">Add Risk Type Field</span>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true" class="text-bold">x</span>
                        </button>
                    </div>
                <form v-on:submit.prevent="addNewRiskTypeField()">
                    <div class="modal-body">
                        <div class="form-group">
                            <label for="field_name">Field Name</label>
                            <input type="text" class="form-control" id="field_name" value=""
                                   placeholder="Enter Risk Type Field Name" v-model="newRiskTypeField.field_name"
                                   required>
                            <span id="field_name_error" class="text-bold text-red" hidden></span>
                        </div>
                        <div class="form-group">
                            <label for="field_type">Field Type</label>
                            <select class="form-control" id="field_type" v-model="newRiskTypeField.field_type"
                                    required>
                                <option value="Integer">Integer</option>
                                <option value="Text">Text</option>
                                <option value="Date">Date</option>
                                <option value="Enum">Enum</option>
                                <option value="CheckBox">CheckBox</option>
                            </select>
                            <span id="field_type_error" class="text-bold text-red" hidden></span>
                        </div>

                        <div v-if="newRiskTypeField.field_type == 'Enum'">

                            <button style="vertical-align: bottom" class="btn btn-success margin-r-5"
                                    v-on:click.prevent="addEnumValue()">Add Enum Value
                            </button>
                            <input style="vertical-align: bottom; height: 35px" type="text" id="enum_value"
                                   placeholder="Enter Enum Value" v-model="currentEnumValue.value"
                                   required="required" >
                            <span id="enum_value_error" class="text-bold text-red" hidden></span>

                            <table class="table table-bordered" id="enum_table">
                                <tbody>
                                    <tr v-for="(enumValue, index) in currentEnumValues">
                                        <td>${enumValue.value}</td>
                                        <td style="width: 20px">
                                             <button class="btn btn-danger btn-sm"
                                                     v-on:click.prevent="deleteEnumValue(index)">
                                                 <i class="fa fa-trash-o fa-lg"></i>
                                             </button>
                                        </td>
                                    </tr>
                                </tbody>

                            </table>

                        </div>

                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-danger m-progress text-bold" data-dismiss="modal">
                            Close
                        </button>
                        <button type="submit" class="btn btn-primary text-bold"
                                v-on:click.prevent="saveAddNewRiskTypeField()">
                            <i class="fa fa-plus"></i>&nbsp;Add New Risk Type Field
                        </button>
                    </div>
                </form>
                </div>
            </div>
        </div>

        <div class="modal fade" id="editRiskTypeFieldModal" tabindex="-1" role="dialog" aria-hidden="true">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <div class="modal-header bg-light-blue-gradient">
                        <span class="modal-title text-bold">Edit Risk Type Field</span>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true" class="text-bold">x</span>
                        </button>
                    </div>
                <form v-on:submit.prevent="saveRiskTypeField()">
                    <div class="modal-body">
                        <div class="form-group">
                            <label for="field_name">Field Name</label>
                            <input type="text" class="form-control" id="edit_field_name" value=""
                                   placeholder="Enter Risk Type Field Name" v-model="currentRiskTypeField.field_name"
                                   required>
                            <span id="edit_field_name_error" class="text-bold text-red" hidden></span>
                        </div>
                        <div class="form-group">
                            <label for="field_type">Field Type</label>
                            <select class="form-control" id="edit_field_type" v-model="currentRiskTypeField.field_type"
                                    required>
                                <option value="Integer">Integer</option>
                                <option value="Text">Text</option>
                                <option value="Date">Date</option>
                                <option value="Enum">Enum</option>
                                <option value="CheckBox">CheckBox</option>
                            </select>
                            <span id="edit_field_type_error" class="text-bold text-red" hidden></span>
                        </div>

                        <div v-if="currentRiskTypeField.field_type == 'Enum'">

                            <button style="vertical-align: bottom" class="btn btn-success margin-r-5"
                                    v-on:click.prevent="addEditEnumValue()">Add Enum Value
                            </button>
                            <input style="vertical-align: bottom; height: 35px" type="text" id="edit_enum_value"
                                   placeholder="Enter Enum Value" v-model="currentEditEnumValue.value"
                                   required="required" >
                            <span id="edit_enum_value_error" class="text-bold text-red" hidden></span>

                            <table class="table table-bordered" id="edit_enum_table">
                                <tbody>
                                    <tr v-for="(enumEditValue, edit_index) in currentEditEnumValues">
                                        <td>${enumEditValue.value}</td>
                                        <td style="width: 20px">
                                             <button class="btn btn-danger btn-sm"
                                                     v-on:click.prevent="deleteEditEnumValue(edit_index)">
                                                 <i class="fa fa-trash-o fa-lg"></i>
                                             </button>
                                        </td>
                                    </tr>
                                </tbody>
                            </table>

                        </div>

                    </div>

                    <div class="modal-footer">
                        <button type="button" class="btn btn-danger m-progress text-bold" data-dismiss="modal">
                            Close
                        </button>
                        <button type="submit" class="btn btn-primary text-bold"
                                v-on:click.prevent="saveEditedRiskTypeField()">
                            <i class="fa fa-plus"></i>&nbsp;Save Risk Type Field
                        </button>
                    </div>
                </form>
                </div>
            </div>
        </div>

    </div>

{% endblock %}

{% block javascript %}
    {{ block.super }}

    <script type="text/javascript" src="{% static 'js/risk_types_edit.js' %}"></script>
{% endblock %}
